	.text

goforit:	
	  move.w  #127,-(a7)		; execute illegal XBIOS call, result
          trap    #14			; is that a0 points to start of trap
          adda.l  #2,a7 		; 14 jump table +2.

          suba.l  #2,a0 
          move.l  a0,trap14table	; move a0 to trap14table
 
          pea     setmytrap		; Enter superexec to execute routine
          move.w  #$26,-(a7) 		; below which installs new trap vector
          trap    #$E
          adda.l  #6,a7 

          move.w  #4,-(a7)		; Get screen resolution to determine
          trap    #$E			; where mouse position boundaries are.
          adda.l  #2,a7 

          cmpi.w  #2,d0 
          bne.s   notmono

          move.w  #18,menuy		; boundary to L100F8 
          move.w  #19,menuyy 
          bra.s   term

notmono:  move.w  #10,menuy
          move.w  #11,menuyy

term:     movea.l 4(a7),a0		; Compute size of this program
          move.l  $C(a0),d0 		; roughly
          add.l   #$100,d0

          clr.l   -(a7) 		; Terminate and stay resident
          move.l  d0,-(a7)
          move.w  #$31,-(a7)
          trap    #1 

setmytrap:
          lea     mytrap14,a0 		; Install new trap 14 vector
          move.l  a0,$B8
          rts 

*------------------The new trap 14 handler is below-------------------

mytrap14: movea.l $4A2,a1 		; Pointer to BIOS register save area
          move.w  (a7)+,d0		; Put SR into d0 (from trap call)
          move.w  d0,-(a1)		; push SR
          move.l  (a7)+,-(a1) 		; push return address
          movem.l d3-d7/a3-a7,-(a1) 	; push all registers
          move.l  a1,$4A2 		; save new BIOS reg. save area pointer

          btst.l  #13,d0		; Check whether call was from super mode
          bne.s   supermode		; and use proper stack pointer
          move    usp,a7

supermode:
          movea.l trap14table,a0 	; The system trap 14 jump table pointer
          move.w  (a7)+,d0		; The function number goes to d0
          cmp.w   (a0)+,d0		; If the number is bigger than no. funs.
          bge.s   done			; then leave

          cmpi.w  #0,d0 		; If the function no. is not INITMOUSE
          bne.s   doit			; then perform that function as usual

          cmpi.w  #1,(a7) 		; Otherwise check if relative mode
          bne.s   doit			; If not then perform the function

          movea.l 6(a7),a3
	  move.l  #here+2,a6
          move.l  a3,(a6) 
          lea     doit_toit,a3 
          move.l  a3,6(a7)

doit:     lsl.w   #2,d0 
          move.l  0(a0,d0.w),d0 
          movea.l d0,a0 
          bpl.s   direct
          movea.l (a0),a0 
direct:   movea.l #0,a5 
          jsr     (a0)

done:     movea.l $4A2,a1 
          movem.l (a1)+,d3-d7/a3-a7 
          move.l  (a1)+,-(a7) 
          move.w  (a1)+,-(a7) 
          move.l  a1,$4A2 
          rte 

menuy:
	  .dc.w    0 
menuyy:
	  .dc.w    0 
trap14table:
          .dc.l    0 


*------------------The new mouse data packet handler-------------------

doit_toit:
          tst.b   $27E7 		; If we are supposed to ignore the
          bne     here			; mouse then leave

          move.l  d0,-(a7)		; Save d0 so we can use it 
          move.l  d1,-(a7)

	  cmpi.b  #1,try		; If try is set then we have to re-hit
          ble     AT			; the mouse button
	  subi.b  #1,try		; and generate some phoney movement
          move.b  #0,2(a0)
	  bra     leave

AT:       move.w  $26E2,d0              ; d0 has the previous mouse position
          move.b  2(a0),d1		; Get the delta y value
          ext.w   d1    		; sign extend the number
          add.w   $26E2,d1		; d1 has the new mouse position

	  cmpi.b  #0,2(a0)
	  bne	  AP
	  cmpi.b  #2,menu
          bne     leave
          btst.b  #1,(a0)
          beq     leave
	  move.b  #1,button
	  move.b  #0,menu
          bra     leave
	  
AP:	  cmp.w   menuyy,d0		; If previous position in menu bar
          bgt     B1
          beq     B20
          cmp.w   menuy,d1              ; and new position in menu bar
          bgt     B2
          btst.b  #1,(a0)		; and the button is pressed
          beq     B3
	  move.b  #1,button
          bra     leave                 ; then do nothing and leave

B20:	  cmpi.b  #0,menu		; If in menu mode then make no change
          bgt     leave
          cmp.w   menuyy,d1             ; If new position is in menu
          bgt     B4	
	  cmp.w   #0,d1			; and in the screen
          ble     B25
          btst.b  #1,(a0)               ; and button is off
          bne     B27
	  move.b  #0,button		; then stay in critical region
	  bra     B8

B27:	  cmpi.b  #1,button		; if button on and old button is on
          beq     B8			; then stay in critical region
          bra     B10			; otherwise move into menu
	  
B25:	  btst.b  #1,(a0)		; If button is off
          bne     B28 			; then stay in critical region
          move.b  #0,button
          bra     B8

B28:	  cmpi.b  #1,button		; if button on and old button is on
	  beq     B8			; then stay in critical region
          bra     B10

B3:	  move.b  #2,menu		; If the button is not pressed
          move.b  #0,button
          bra     leave                 ; then menu mode is 2

B2:       btst.b  #1,(a0)		; If new pos. not menu, prv. pos. menu
          beq     B3                    ; button not pressed go to A3
	  move.b  #1,button
          bra     leave                 ; otherwise leave (button pressed)

B1:	  cmp.w   menuy,d1		; If prev. pos. not menu, new pos menu
          bgt     B4
          cmp.w   #0,d1                 ; and new position in screen
          ble     B5
          btst.b  #1,(a0)               ; and button is off
          bne     B6
	  move.b  #0,button
          cmpi.b  #2,menu               ; and menu mode is 2
          beq     leave                 ; then leave.  If menu mode not 2


B8:       move.b  #0,menu		; then set mode to 0
	  move.w  menuyy,d0             ; Set delta y to put mouse in critical
          sub.w   $26E2,d0              ; region and leave
	  move.b  d0,2(a0)
	  bra     leave

B6:	  cmpi.b  #0,menu	        ; If menu mode is 0 
          bne     B21
          move.b  #1,button		; if the button is on then set button
          bra     B8			; to 1 and stay

B21:      move.b  #1,button
          cmpi.b  #1,menu               ; If menu mode is 1 then leave
          beq     leave
          bra     B8			; otherwise branch to A8
          
B5:	  btst.b  #1,(a0)               ; If button off
          bne     B9
          move.b  #0,button
          cmpi.b  #2,menu               ; and menu mode is not 2 then
          beq     B12                    ; then set pointer to critical region
          bra     B8

B12:	  move.w  #1,d0                 ; Set delta y to put mouse at zero
          sub.w   $26E2,d0              ; and leave
	  move.b  d0,2(a0)
	  bra     leave

B9:       cmpi.b  #1,menu		; If menu mode 1 (button on, off screen)
          beq     B12			; then put pointer at position 0
          cmpi.b  #2,menu               ; If menu mode 2
          beq     B12
          move.b  #1,button
          bra     B8

B10:      move.w  $26E2,d0              ; d0 has the previous mouse position
          sub.w   menuy,d0		; Set delta y to put mouse in menu bar
          add.w   #12,d0
          not.w   d0
          move.b  d0,2(a0)		; 
	  move.b  #1,menu		; Set menu mode to 1 
	  bclr.b  #1,(a0)		; Simulate button release
          move.b  #10,try                ; Set try (length of time for release)
          move.b  #1,button
          bra     leave			; and leave

B4:	  btst.b  #1,(a0)		; If button is pressed
          beq     B11
	  move.b  #1,button
          cmpi.b  #2,menu		; and menu mode is less than 2 then
          blt     leave			; leave
          move.b  #0,menu		; otherwise set menu mode to 0
          bra     leave

B11:      move.b  #0,button
          cmpi.b  #1,menu		; If menu mode is not equal to 1 then
          bne     leave			; leave.  Otherwise set menu mode to
          move.b  #0,menu		; 0
          
leave:    move.l  (a7)+,d1
          move.l  (a7)+,d0
here:     jmp     $12345678 

menu:     .dc.b   0
try:      .dc.b   0
button:   .dc.b   0
 
	  .end
